Subject: Re: [yang-doctors] [netconf] WGLC: draft-ietf-netconf-notification-capabilities-11

From: Mahesh Jethanandani <[email-masked]>
Date: Thu, 12 Mar 2020 14:28:12 -0700

[Adding yang-doctors]

Hi Balazs,

On Mar 10, 2020, at 2:06 AM, Balázs Lengyel <[email-masked]> wrote:

Finally, have all the examples in the appendix been validated?
BALAZS: Yes, they have been loaded into a live Confd server.

I bring this up because I ran into issues when validating the https-notif model using ietf-subscribed-notification module, something that you also import. Here is what I see when I try to use yanglint to validate your example. In this case, I named your example as examples-notification-capabilities-1.xml.

bash-3.2$ yanglint -s -i -t auto -p /Volumes/External/git/iana/yang-parameters/ [email-masked] [email-masked] examples-notification-capabilities-1.xml 
err : Invalid keyword "require-instance".
err : Module "ietf-subscribed-notifications" parsing failed.
err : Importing "ietf-subscribed-notifications" module into "ietf-yang-push" failed.
err : Module "ietf-yang-push" parsing failed.
err : Importing "ietf-yang-push" module into "ietf-notification-capabilities" failed.
err : Module "ietf-notification-capabilities" parsing failed.

At first I thought the issue was with yanglint, because just like you I used confd and it did not complain. But folks over at libyang tell me that this was discussed as part of their issue  #881 <https://github.com/CESNET/libyang/issues/881> and the conclusion was that you cannot put require-instance in a derived type based on this <https://tools.ietf.org/html/rfc7950#section-9.9.3> text.

Who is correct in their assertion, libyang or confd/RFC8639?

In case anyone is wondering which ietf-subsciribed-notifications module is being imported, here it is:

bash-3.2$ ls ../iana/yang-parameters/[email-masked] <mailto:iana/yang-parameters/[email-masked]>

Cheers.

BTW, even if I comment out the ‘require-instance’ statement, yanglint complains about other issues with ietf-subscribed-notifications, which I will bring up in a separate thread.

Mahesh Jethanandani
[email-masked]